using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using System.Threading;
using System.Text;
using ULabTools;


namespace ULabTools
{
	#region StampActions
	public enum StampActions
	{
		EditedBy = 1,
		DateTime = 2,
		Custom = 4
	}
	#endregion

	/// <summary>
	/// An extended RichTextBox that contains a toolbar.
	/// </summary>
	public class RichTextBoxExtended : System.Windows.Forms.UserControl
	{
		#region Windows Generated

		private System.Windows.Forms.RichTextBox rtb1;
		private System.Windows.Forms.ImageList imgList1;
		private System.Windows.Forms.OpenFileDialog ofd1;
		private System.Windows.Forms.SaveFileDialog sfd1;
		private System.Windows.Forms.StatusBar statusBar1;
		private Syncfusion.Windows.Forms.Tools.XPMenus.XPToolBar xpToolBar1;
		private Syncfusion.Windows.Forms.Tools.FontListBox fontListBox1;
		private Syncfusion.Windows.Forms.Tools.XPMenus.ComboBoxBarItem cbFont;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem btSave;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem btOpen;
		private Syncfusion.Windows.Forms.Tools.XPMenus.ComboBoxBarItem cbSize;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem btBold;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem btItalic;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem btUnderline;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem btStrikeout;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem btLeft;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem btCenter;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem btRight;
		private Syncfusion.Windows.Forms.Tools.XPMenus.DropDownBarItem btColor;
		private Syncfusion.Windows.Forms.ColorUIControl colorUIControl1;
		private Syncfusion.Windows.Forms.PopupControlContainer popupControlContainer1;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem btUndo;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem btRedo;
		private System.ComponentModel.IContainer components;

		public RichTextBoxExtended()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			//Update the graphics on the toolbar
			UpdateToolbar();
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}
		#endregion

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(RichTextBoxExtended));
			this.imgList1 = new System.Windows.Forms.ImageList(this.components);
			this.rtb1 = new System.Windows.Forms.RichTextBox();
			this.ofd1 = new System.Windows.Forms.OpenFileDialog();
			this.sfd1 = new System.Windows.Forms.SaveFileDialog();
			this.statusBar1 = new System.Windows.Forms.StatusBar();
			this.xpToolBar1 = new Syncfusion.Windows.Forms.Tools.XPMenus.XPToolBar();
			this.btOpen = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.btSave = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.cbFont = new Syncfusion.Windows.Forms.Tools.XPMenus.ComboBoxBarItem();
			this.fontListBox1 = new Syncfusion.Windows.Forms.Tools.FontListBox();
			this.cbSize = new Syncfusion.Windows.Forms.Tools.XPMenus.ComboBoxBarItem();
			this.btColor = new Syncfusion.Windows.Forms.Tools.XPMenus.DropDownBarItem();
			this.popupControlContainer1 = new Syncfusion.Windows.Forms.PopupControlContainer(this.components);
			this.colorUIControl1 = new Syncfusion.Windows.Forms.ColorUIControl();
			this.btBold = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.btItalic = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.btUnderline = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.btStrikeout = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.btLeft = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.btCenter = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.btRight = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.btUndo = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.btRedo = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.popupControlContainer1.SuspendLayout();
			this.SuspendLayout();
			// 
			// imgList1
			// 
			this.imgList1.ColorDepth = System.Windows.Forms.ColorDepth.Depth32Bit;
			this.imgList1.ImageSize = new System.Drawing.Size(16, 16);
			this.imgList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imgList1.ImageStream")));
			this.imgList1.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// rtb1
			// 
			this.rtb1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.rtb1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.rtb1.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.rtb1.Location = new System.Drawing.Point(0, 24);
			this.rtb1.Name = "rtb1";
			this.rtb1.ShowSelectionMargin = true;
			this.rtb1.Size = new System.Drawing.Size(568, 216);
			this.rtb1.TabIndex = 1;
			this.rtb1.Text = "";
			this.rtb1.WordWrap = false;
			this.rtb1.LinkClicked += new System.Windows.Forms.LinkClickedEventHandler(this.rtb1_LinkClicked);
			this.rtb1.SelectionChanged += new System.EventHandler(this.rtb1_SelectionChanged);
			// 
			// ofd1
			// 
			this.ofd1.DefaultExt = "rtf";
			this.ofd1.Filter = "Rich Text Files|*.rtf|Plain Text File|*.txt";
			this.ofd1.Title = "Open File";
			// 
			// sfd1
			// 
			this.sfd1.DefaultExt = "rtf";
			this.sfd1.Filter = "Rich Text File|*.rtf|Plain Text File|*.txt";
			this.sfd1.Title = "Save As";
			// 
			// statusBar1
			// 
			this.statusBar1.Location = new System.Drawing.Point(0, 240);
			this.statusBar1.Name = "statusBar1";
			this.statusBar1.Size = new System.Drawing.Size(568, 16);
			this.statusBar1.SizingGrip = false;
			this.statusBar1.TabIndex = 3;
			this.statusBar1.Text = "0/0";
			// 
			// xpToolBar1
			// 
			this.xpToolBar1.Bar = new Syncfusion.Windows.Forms.Tools.XPMenus.Bar(null, "", ((Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle)(((Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.AllowQuickCustomizing | Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.Visible) 
				| Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.DrawDragBorder))), null, null);
			this.xpToolBar1.Dock = System.Windows.Forms.DockStyle.Top;
			this.xpToolBar1.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.xpToolBar1.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																									this.btOpen,
																									this.btSave,
																									this.btUndo,
																									this.btRedo,
																									this.cbFont,
																									this.cbSize,
																									this.btColor,
																									this.btBold,
																									this.btItalic,
																									this.btUnderline,
																									this.btStrikeout,
																									this.btLeft,
																									this.btCenter,
																									this.btRight});
			this.xpToolBar1.Location = new System.Drawing.Point(0, 0);
			this.xpToolBar1.Name = "xpToolBar1";
			this.xpToolBar1.SeparatorIndices.AddRange(new int[] {
																	2,
																	4,
																	7,
																	11});
			this.xpToolBar1.Size = new System.Drawing.Size(568, 25);
			this.xpToolBar1.Style = Syncfusion.Windows.Forms.VisualStyle.Office2003;
			this.xpToolBar1.TabIndex = 4;
			this.xpToolBar1.Text = "xpToolBar1";
			// 
			// btOpen
			// 
			this.btOpen.CategoryIndex = -1;
			this.btOpen.ID = "ffnen";
			this.btOpen.ImageIndex = 10;
			this.btOpen.ImageList = this.imgList1;
			this.btOpen.Tag = "open";
			this.btOpen.Text = "ffnen";
			this.btOpen.Tooltip = "Datei ffnen";
			this.btOpen.Click += new System.EventHandler(this.btOpen_Click);
			// 
			// btSave
			// 
			this.btSave.CategoryIndex = -1;
			this.btSave.ID = "Speichern";
			this.btSave.ImageIndex = 11;
			this.btSave.ImageList = this.imgList1;
			this.btSave.Tag = "save";
			this.btSave.Text = "Speichern";
			this.btSave.Tooltip = "Speichern";
			this.btSave.Click += new System.EventHandler(this.btSave_Click);
			// 
			// cbFont
			// 
			this.cbFont.CategoryIndex = -1;
			this.cbFont.ID = "";
			this.cbFont.ListBox = this.fontListBox1;
			this.cbFont.MinWidth = 150;
			this.cbFont.Tag = "font";
			this.cbFont.Click += new System.EventHandler(this.cbFont_Click);
			// 
			// fontListBox1
			// 
			this.fontListBox1.DrawMode = System.Windows.Forms.DrawMode.OwnerDrawVariable;
			this.fontListBox1.Location = new System.Drawing.Point(552, 24);
			this.fontListBox1.Name = "fontListBox1";
			this.fontListBox1.Size = new System.Drawing.Size(8, 13);
			this.fontListBox1.TabIndex = 5;
			this.fontListBox1.Visible = false;
			// 
			// cbSize
			// 
			this.cbSize.CategoryIndex = -1;
			this.cbSize.ChoiceList.AddRange(new string[] {
															 "8",
															 "9",
															 "10",
															 "11",
															 "12",
															 "13",
															 "14",
															 "15",
															 "16",
															 "17",
															 "18",
															 "19",
															 "20",
															 "22",
															 "24",
															 "26",
															 "28",
															 "30",
															 "34",
															 "40",
															 "46",
															 "52",
															 "60",
															 "72",
															 "96"});
			this.cbSize.ID = "";
			this.cbSize.Tag = "size";
			this.cbSize.Tooltip = "Schriftgre";
			this.cbSize.Click += new System.EventHandler(this.cbSize_Click);
			// 
			// btColor
			// 
			this.btColor.CategoryIndex = -1;
			this.btColor.ID = "Farbe";
			this.btColor.ImageIndex = 20;
			this.btColor.ImageList = this.imgList1;
			this.btColor.PopupControlContainer = this.popupControlContainer1;
			this.btColor.Tag = "color";
			this.btColor.Text = "Farbe";
			this.btColor.Tooltip = "Farbe";
			this.btColor.Click += new System.EventHandler(this.btColor_Click);
			// 
			// popupControlContainer1
			// 
			this.popupControlContainer1.Controls.Add(this.colorUIControl1);
			this.popupControlContainer1.Location = new System.Drawing.Point(64, 64);
			this.popupControlContainer1.Name = "popupControlContainer1";
			this.popupControlContainer1.Size = new System.Drawing.Size(208, 176);
			this.popupControlContainer1.TabIndex = 7;
			// 
			// colorUIControl1
			// 
			this.colorUIControl1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.colorUIControl1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.colorUIControl1.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.colorUIControl1.Location = new System.Drawing.Point(0, 0);
			this.colorUIControl1.Name = "colorUIControl1";
			this.colorUIControl1.SelectedColor = System.Drawing.SystemColors.WindowText;
			this.colorUIControl1.Size = new System.Drawing.Size(208, 176);
			this.colorUIControl1.TabIndex = 6;
			this.colorUIControl1.Text = "colorUIControl1";
			this.colorUIControl1.ColorSelected += new System.EventHandler(this.colorUIControl1_ColorSelected);
			// 
			// btBold
			// 
			this.btBold.CategoryIndex = -1;
			this.btBold.ID = "Fett";
			this.btBold.ImageIndex = 17;
			this.btBold.ImageList = this.imgList1;
			this.btBold.Tag = "bold";
			this.btBold.Text = "Fett";
			this.btBold.Tooltip = "Fett";
			this.btBold.Click += new System.EventHandler(this.btBold_Click);
			// 
			// btItalic
			// 
			this.btItalic.CategoryIndex = -1;
			this.btItalic.ID = "Kursiv";
			this.btItalic.ImageIndex = 18;
			this.btItalic.ImageList = this.imgList1;
			this.btItalic.Tag = "italic";
			this.btItalic.Text = "Kursiv";
			this.btItalic.Tooltip = "Kursiv";
			this.btItalic.Click += new System.EventHandler(this.btItalic_Click);
			// 
			// btUnderline
			// 
			this.btUnderline.CategoryIndex = -1;
			this.btUnderline.ID = "Unterstrichen";
			this.btUnderline.ImageIndex = 2;
			this.btUnderline.ImageList = this.imgList1;
			this.btUnderline.Tag = "underline";
			this.btUnderline.Text = "Unterstrichen";
			this.btUnderline.Tooltip = "Unterstrichen";
			this.btUnderline.Click += new System.EventHandler(this.btUnderline_Click);
			// 
			// btStrikeout
			// 
			this.btStrikeout.CategoryIndex = -1;
			this.btStrikeout.ID = "Durchgestrichen";
			this.btStrikeout.ImageIndex = 19;
			this.btStrikeout.ImageList = this.imgList1;
			this.btStrikeout.Tag = "strikeout";
			this.btStrikeout.Text = "Durchgestrichen";
			this.btStrikeout.Tooltip = "Durchgestrichen";
			this.btStrikeout.Click += new System.EventHandler(this.btStrikeout_Click);
			// 
			// btLeft
			// 
			this.btLeft.CategoryIndex = -1;
			this.btLeft.ID = "linksbndig";
			this.btLeft.ImageIndex = 4;
			this.btLeft.ImageList = this.imgList1;
			this.btLeft.Tag = "left";
			this.btLeft.Text = "linksbndig";
			this.btLeft.Tooltip = "linksbndig";
			this.btLeft.Click += new System.EventHandler(this.btLeft_Click);
			// 
			// btCenter
			// 
			this.btCenter.CategoryIndex = -1;
			this.btCenter.ID = "Zentriert";
			this.btCenter.ImageIndex = 5;
			this.btCenter.ImageList = this.imgList1;
			this.btCenter.Tag = "center";
			this.btCenter.Text = "Zentriert";
			this.btCenter.Tooltip = "zentriert";
			this.btCenter.Click += new System.EventHandler(this.btCenter_Click);
			// 
			// btRight
			// 
			this.btRight.CategoryIndex = -1;
			this.btRight.ID = "Rechtsbndig";
			this.btRight.ImageIndex = 6;
			this.btRight.ImageList = this.imgList1;
			this.btRight.Tag = "right";
			this.btRight.Text = "Rechtsbndig";
			this.btRight.Tooltip = "rechtsbndig";
			this.btRight.Click += new System.EventHandler(this.btRight_Click);
			// 
			// btUndo
			// 
			this.btUndo.CategoryIndex = -1;
			this.btUndo.ID = "Rckgngig";
			this.btUndo.ImageIndex = 12;
			this.btUndo.ImageList = this.imgList1;
			this.btUndo.Tag = "undo";
			this.btUndo.Text = "Rckgngig";
			this.btUndo.Tooltip = "Rckgngig";
			this.btUndo.Click += new System.EventHandler(this.btUndo_Click);
			// 
			// btRedo
			// 
			this.btRedo.CategoryIndex = -1;
			this.btRedo.ID = "Wiederherstellen";
			this.btRedo.ImageIndex = 13;
			this.btRedo.ImageList = this.imgList1;
			this.btRedo.Tag = "redo";
			this.btRedo.Text = "Wiederherstellen";
			this.btRedo.Tooltip = "Wiederherstellen";
			this.btRedo.Click += new System.EventHandler(this.btRedo_Click);
			// 
			// RichTextBoxExtended
			// 
			this.Controls.Add(this.xpToolBar1);
			this.Controls.Add(this.rtb1);
			this.Controls.Add(this.statusBar1);
			this.Controls.Add(this.popupControlContainer1);
			this.Controls.Add(this.fontListBox1);
			this.Font = new System.Drawing.Font("Tahoma", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Name = "RichTextBoxExtended";
			this.Size = new System.Drawing.Size(568, 256);
			this.popupControlContainer1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		#region Stamp Event Stuff
		[Description("Occurs when the stamp button is clicked"), 
		 Category("Behavior")]
		public event System.EventHandler Stamp;
        
		/// <summary>
		/// OnStamp event
		/// </summary>
		protected virtual void OnStamp(EventArgs e)
		{
			if(Stamp != null)
				Stamp(this, e);

			switch(StampAction)
			{
				case StampActions.EditedBy:
				{
					StringBuilder stamp = new StringBuilder(""); //holds our stamp text
					if(rtb1.Text.Length > 0) stamp.Append("\r\n\r\n"); //add two lines for space
					stamp.Append("Bearbeitet von "); 
					//use the CurrentPrincipal name if one exsist else use windows logon username
					if(Thread.CurrentPrincipal == null || Thread.CurrentPrincipal.Identity == null || Thread.CurrentPrincipal.Identity.Name.Length <= 0)
						stamp.Append(Environment.UserName);
					else
						stamp.Append(Thread.CurrentPrincipal.Identity.Name);
					stamp.Append(" am " + DateTime.Now.ToLongDateString() + "\r\n");
			
					rtb1.SelectionLength = 0; //unselect everything basicly
					rtb1.SelectionStart = rtb1.Text.Length; //start new selection at the end of the text
					rtb1.SelectionColor = this.StampColor; //make the selection blue
					rtb1.SelectionFont = new Font(rtb1.SelectionFont, FontStyle.Bold); //set the selection font and style
					rtb1.AppendText(stamp.ToString()); //add the stamp to the richtextbox
					rtb1.Focus(); //set focus back on the richtextbox
				} break; //end edited by stamp
				case StampActions.DateTime:
				{
					StringBuilder stamp = new StringBuilder(""); //holds our stamp text
					if(rtb1.Text.Length > 0) stamp.Append("\r\n\r\n"); //add two lines for space
					stamp.Append(DateTime.Now.ToLongDateString() + "\r\n");
					rtb1.SelectionLength = 0; //unselect everything basicly
					rtb1.SelectionStart = rtb1.Text.Length; //start new selection at the end of the text
					rtb1.SelectionColor = this.StampColor; //make the selection blue
					rtb1.SelectionFont = new Font(rtb1.SelectionFont, FontStyle.Bold); //set the selection font and style
					rtb1.AppendText(stamp.ToString()); //add the stamp to the richtextbox
					rtb1.Focus(); //set focus back on the richtextbox
				} break;
			} //end select
		}
		#endregion

		#region Toolbar button click
		/// <summary>
		///     Handler for the toolbar button click event
		/// </summary>
		private void tb1_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{
		}

		private void btBold_Click(object sender, System.EventArgs e)
		{
			if(rtb1.SelectionFont != null) 
			{
				//using bitwise Exclusive OR to flip-flop the value
				rtb1.SelectionFont = new Font(rtb1.SelectionFont, rtb1.SelectionFont.Style ^ FontStyle.Bold);
			}
			UpdateToolbar(); //Update the toolbar buttons
		}

		private void btItalic_Click(object sender, System.EventArgs e)
		{
			if(rtb1.SelectionFont != null) 
			{
				//using bitwise Exclusive OR to flip-flop the value
				rtb1.SelectionFont = new Font(rtb1.SelectionFont, rtb1.SelectionFont.Style ^ FontStyle.Italic);
			}
			UpdateToolbar(); //Update the toolbar buttons
		}

		private void btStrikeout_Click(object sender, System.EventArgs e)
		{
			if(rtb1.SelectionFont != null) 
			{
				//using bitwise Exclusive OR to flip-flop the value
				rtb1.SelectionFont = new Font(rtb1.SelectionFont, rtb1.SelectionFont.Style ^ FontStyle.Strikeout);
			}
			UpdateToolbar(); //Update the toolbar buttons
		}

		private void btUnderline_Click(object sender, System.EventArgs e)
		{
			if(rtb1.SelectionFont != null) 
			{
				//using bitwise Exclusive OR to flip-flop the value
				rtb1.SelectionFont = new Font(rtb1.SelectionFont, rtb1.SelectionFont.Style ^ FontStyle.Underline);
			}
			UpdateToolbar(); //Update the toolbar buttons
		}

		private void btCenter_Click(object sender, System.EventArgs e)
		{
			//change horizontal alignment to center
			rtb1.SelectionAlignment = HorizontalAlignment.Center;
			UpdateToolbar(); //Update the toolbar buttons
		}

		private void btLeft_Click(object sender, System.EventArgs e)
		{
			//change horizontal alignment to left
			rtb1.SelectionAlignment = HorizontalAlignment.Left; 
			UpdateToolbar(); //Update the toolbar buttons
		}

		private void btRight_Click(object sender, System.EventArgs e)
		{
			//change horizontal alignment to right
			rtb1.SelectionAlignment = HorizontalAlignment.Right;
			UpdateToolbar(); //Update the toolbar buttons
		}

		private void btColor_Click(object sender, System.EventArgs e)
		{
			rtb1.SelectionColor = Color.Black;
			UpdateToolbar(); //Update the toolbar buttons
		}

		private void btRedo_Click(object sender, System.EventArgs e)
		{
			rtb1.Redo();
			UpdateToolbar(); //Update the toolbar buttons
		}

		private void btUndo_Click(object sender, System.EventArgs e)
		{
			rtb1.Undo();
			UpdateToolbar(); //Update the toolbar buttons
		}

		private void btSave_Click(object sender, System.EventArgs e)
		{
			if(sfd1.ShowDialog() == DialogResult.OK && sfd1.FileName.Length > 0)
				if(System.IO.Path.GetExtension(sfd1.FileName).ToLower().Equals(".rtf"))
					rtb1.SaveFile(sfd1.FileName);
				else
					rtb1.SaveFile(sfd1.FileName, RichTextBoxStreamType.PlainText);
			UpdateToolbar(); //Update the toolbar buttons
		}

		private void btOpen_Click(object sender, System.EventArgs e)
		{
			try
			{
				if (ofd1.ShowDialog() == DialogResult.OK && ofd1.FileName.Length > 0)
					if(System.IO.Path.GetExtension(ofd1.FileName).ToLower().Equals(".rtf")) 
						rtb1.LoadFile(ofd1.FileName, RichTextBoxStreamType.RichText);
					else
						rtb1.LoadFile(ofd1.FileName, RichTextBoxStreamType.PlainText);
			}
			catch (ArgumentException ae)
			{
				if(ae.Message == "Invalid file format.")
					MessageBox.Show("There was an error loading the file: " + ofd1.FileName);				
			}
			UpdateToolbar(); //Update the toolbar buttons
		}



		#endregion

		#region Update Toolbar
		/// <summary>
		///     Update the toolbar button statuses
		/// </summary>
		/// 
		public void UpdateStatusBar()
		{
			string strStatus;
			int nLine, nAllLine, nChar, nLineChar;
			nLine = rtb1.GetLineFromCharIndex(rtb1.SelectionStart);
			nAllLine = rtb1.Lines.Length;
			nChar = 0;
			for ( int i = 0; i < nLine; i++ )
			{
				nChar += rtb1.Lines[i].Length + 1;
			}
			nLineChar = rtb1.SelectionStart - nChar;

			string strTemp = "";
			if ( rtb1.Lines.Length > 0 )
			{
				if ( rtb1.Lines[nLine].Length >= 60 )
					strTemp = "  -  ACHTUNG !  Mehr als 60 Zeichen in dieser Zeile !";
				else
					strTemp = "";
			}

			strStatus = string.Format( "{0} / {1} {2}", nLineChar, nLine + 1, strTemp);
			statusBar1.Text = strStatus;

		}

		public void UpdateToolbar()
		{
			UpdateStatusBar();

			//This is done incase 2 different fonts are selected at the same time
			//If that is the case there is no selection font so I use the default
			//font instead.
			Font fnt;
			if(rtb1.SelectionFont != null)
				fnt = rtb1.SelectionFont;
			else
				fnt = rtb1.Font;

			//Do all the toolbar button checks
			this.btBold.Checked = fnt.Bold;
			this.btItalic.Checked = fnt.Italic;
			this.btUnderline.Checked = fnt.Underline;
			this.btStrikeout.Checked = fnt.Strikeout;
			this.btRight.Checked		= (rtb1.SelectionAlignment == HorizontalAlignment.Right); //justify right
			this.btLeft.Checked		= (rtb1.SelectionAlignment == HorizontalAlignment.Left); //justify left
			this.btCenter.Checked	= (rtb1.SelectionAlignment == HorizontalAlignment.Center); //justify center

			this.cbFont.TextBoxValue = fnt.FontFamily.Name;
			//Check the correct font size
			this.cbSize.TextBoxValue = fnt.SizeInPoints.ToString();

			//Check the correct color
			this.colorUIControl1.SelectedColor = rtb1.SelectionColor;

		}
		#endregion

		#region Update Toolbar Seperators
		private void UpdateToolbarSeperators()
		{
//			//Save & Open
//			if(!tbbSave.Visible && !tbbOpen.Visible) 
//				tbbSeparator3.Visible = false;
//			else
//				tbbSeparator3.Visible = true;
//
//			//Font & Font Size
//			if(!tbbFont.Visible && !tbbFontSize.Visible) 
//				tbbSeparator5.Visible = false;
//			else
//				tbbSeparator5.Visible = true;
//
//			//Bold, Italic, Underline, & Strikeout
//			if(!tbbBold.Visible && !tbbItalic.Visible && !tbbUnderline.Visible && !tbbStrikeout.Visible)
//				tbbSeparator1.Visible = false;
//			else
//				tbbSeparator1.Visible = true;
//
//			//Left, Center, & Right
//			if(!tbbLeft.Visible && !tbbCenter.Visible && !tbbRight.Visible)
//				tbbSeparator2.Visible = false;
//			else
//				tbbSeparator2.Visible = true;
//
//			//Undo & Redo
//			if(!tbbUndo.Visible && !tbbRedo.Visible) 
//				tbbSeparator4.Visible = false;
//			else
//				tbbSeparator4.Visible = true;
		}
#endregion

		#region RichTextBox Selection Change
		/// <summary>
		///		Change the toolbar buttons when new text is selected
		/// </summary>
		private void rtb1_SelectionChanged(object sender, System.EventArgs e)
		{
			UpdateToolbar(); //Update the toolbar buttons
		}
#endregion

		#region Color Click
		/// <summary>
		///     Change the richtextbox color
		/// </summary>
		private void colorUIControl1_ColorSelected(object sender, System.EventArgs e)
		{
			rtb1.SelectionColor = Color.FromArgb(((Syncfusion.Windows.Forms.ColorUIControl)sender).SelectedColor.ToArgb());
		}


		#endregion

		#region Font Click
		/// <summary>
		///     Change the richtextbox font
		/// </summary>
		private void Font_Click(object sender, System.EventArgs e)
		{
			if(rtb1.SelectionFont != null) 
			{
				//set the richtextbox font family based on the name of the menu item
				rtb1.SelectionFont = new Font(((MenuItem)sender).Text, rtb1.SelectionFont.SizeInPoints);
			}
		}

		private void cbFont_Click(object sender, System.EventArgs e)
		{
			if(rtb1.SelectionFont != null) 
			{
				//set the richtextbox font family based on the name of the menu item
				rtb1.SelectionFont = new Font(this.cbFont.TextBoxValue, rtb1.SelectionFont.SizeInPoints);
			}
		}

		#endregion

		#region Font Size Click
		/// <summary>
		///     Change the richtextbox font size
		/// </summary>
		private void FontSize_Click(object sender, System.EventArgs e)
		{
			//set the richtextbox font size based on the name of the menu item
			rtb1.SelectionFont = new Font(rtb1.SelectionFont.FontFamily.Name, float.Parse(((MenuItem)sender).Text));
		}

		private void cbSize_Click(object sender, System.EventArgs e)
		{
			//set the richtextbox font size based on the name of the menu item
			try
			{
				rtb1.SelectionFont = new Font(rtb1.SelectionFont.FontFamily.Name, Convert.ToSingle(this.cbSize.TextBoxValue));
			}
			catch {}
		}

		#endregion

		#region Link Clicked
		/// <summary>
		/// Starts the default browser if a link is clicked
		/// </summary>
		private void rtb1_LinkClicked(object sender, System.Windows.Forms.LinkClickedEventArgs e)
		{
			System.Diagnostics.Process.Start(e.LinkText);
		}
		#endregion

		#region Public Properties
		/// <summary>
		///     The toolbar that is contained with-in the RichTextBoxExtened control
		/// </summary>
		[Description("The internal toolbar control"),
		Category("Internal Controls")]
		public Syncfusion.Windows.Forms.Tools.XPMenus.XPToolBar Toolbar
		{
			get 
			{
				return  xpToolBar1;
			}
		}

		/// <summary>
		///     The RichTextBox that is contained with-in the RichTextBoxExtened control
		/// </summary>
		[Description("The internal richtextbox control"),
		Category("Internal Controls")]
		public RichTextBox RichTextBox
		{
			get	{ return rtb1; }
		}

		/// <summary>
		///     Show the save button or not
		/// </summary>
		[Description("Show the save button or not"),
		Category("Appearance")]
		public Boolean ShowSave
		{
			get { return btSave.Visible; }
			set { btSave.Visible = value; UpdateToolbarSeperators(); }
		}

		/// <summary>
		///    Show the open button or not 
		/// </summary>
		[Description("Show the open button or not"),
		Category("Appearance")]
		public Boolean ShowOpen
		{
			get { return btOpen.Visible; }
			set	{ btOpen.Visible = value; UpdateToolbarSeperators(); }
		}

		/// <summary>
		///     Show the stamp button or not
		/// </summary>
//		[Description("Show the stamp button or not"),
//		 Category("Appearance")]
//		public Boolean ShowStamp
//		{
//			get { return btStamp.Visible; }
//			set { btStamp.Visible = value; }
//		}
		
		/// <summary>
		///     Show the color button or not
		/// </summary>
		[Description("Show the color button or not"),
		Category("Appearance")]
		public Boolean ShowColors
		{
			get { return btColor.Visible; }
			set { btColor.Visible = value; }
		}

		/// <summary>
		///     Show the undo button or not
		/// </summary>
		[Description("Show the undo button or not"),
		Category("Appearance")]
		public Boolean ShowUndo
		{
			get { return btUndo.Visible; }
			set { btUndo.Visible = value; UpdateToolbarSeperators(); }
		}

		/// <summary>
		///     Show the redo button or not
		/// </summary>
		[Description("Show the redo button or not"),
		Category("Appearance")]
		public Boolean ShowRedo
		{
			get { return btRedo.Visible; }
			set { btRedo.Visible = value; UpdateToolbarSeperators(); }
		}

		/// <summary>
		///     Show the bold button or not
		/// </summary>
		[Description("Show the bold button or not"),
		Category("Appearance")]
		public Boolean ShowBold
		{
			get { return btBold.Visible; }
			set { btBold.Visible = value; UpdateToolbarSeperators(); }
		}

		/// <summary>
		///     Show the italic button or not
		/// </summary>
		[Description("Show the italic button or not"),
		Category("Appearance")]
		public Boolean ShowItalic
		{
			get { return btItalic.Visible; }
			set { btItalic.Visible = value; UpdateToolbarSeperators(); }
		}

		/// <summary>
		///     Show the underline button or not
		/// </summary>
		[Description("Show the underline button or not"),
		Category("Appearance")]
		public Boolean ShowUnderline
		{
			get { return btUnderline.Visible; }
			set { btUnderline.Visible = value; UpdateToolbarSeperators(); }
		}

		/// <summary>
		///     Show the strikeout button or not
		/// </summary>
		[Description("Show the strikeout button or not"),
		Category("Appearance")]
		public Boolean ShowStrikeout
		{
			get { return btStrikeout.Visible; }
			set { btStrikeout.Visible = value; UpdateToolbarSeperators(); }
		}

		/// <summary>
		///     Show the left justify button or not
		/// </summary>
		[Description("Show the left justify button or not"),
		Category("Appearance")]
		public Boolean ShowLeftJustify
		{
			get { return btLeft.Visible; }
			set { btLeft.Visible = value; UpdateToolbarSeperators(); }
		}

		/// <summary>
		///     Show the right justify button or not
		/// </summary>
		[Description("Show the right justify button or not"),
		Category("Appearance")]
		public Boolean ShowRightJustify
		{
			get { return btRight.Visible; }
			set { btRight.Visible = value; UpdateToolbarSeperators(); }
		}

		/// <summary>
		///     Show the center justify button or not
		/// </summary>
		[Description("Show the center justify button or not"),
		Category("Appearance")]
		public Boolean ShowCenterJustify
		{
			get { return btCenter.Visible; }
			set { btCenter.Visible = value; UpdateToolbarSeperators(); }
		}

		/// <summary>
		///     Determines how the stamp button will respond
		/// </summary>
		StampActions m_StampAction = StampActions.EditedBy;
		[Description("Determines how the stamp button will respond"),
		Category("Behavior")]
		public StampActions StampAction
		{
			get { return m_StampAction; }
			set { m_StampAction = value; }
		}
		
		/// <summary>
		///     Color of the stamp text
		/// </summary>
		Color m_StampColor = Color.Blue;


		[Description("Color of the stamp text"),
		Category("Appearance")]
		public Color StampColor
		{
			get { return m_StampColor; }
			set { m_StampColor = value; }
		}
			
		/// <summary>
		///     Show the font button or not
		/// </summary>
		[Description("Show the font button or not"),
		Category("Appearance")]
		public Boolean ShowFont
		{
			get { return cbFont.Visible; }
			set { cbFont.Visible = value; }
		}

		/// <summary>
		///     Show the font size button or not
		/// </summary>
		[Description("Show the font size button or not"),
		Category("Appearance")]
		public Boolean ShowFontSize
		{
			get { return cbSize.Visible; }
			set { cbSize.Visible = value; }
		}

		/// <summary>
		///     Detect URLs with-in the richtextbox
		/// </summary>
		[Description("Detect URLs with-in the richtextbox"),
		Category("Behavior")]
		public Boolean DetectURLs
		{
			get { return rtb1.DetectUrls; }
			set { rtb1.DetectUrls = value; }
		}
		#endregion


	} //end class
} //end namespace
